"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _validator = _interopRequireDefault(require("./validator"));

var _visitorManager = _interopRequireDefault(require("./visitorManager"));

var Configuration = function Configuration() {
  (0, _classCallCheck2.default)(this, Configuration);
  (0, _defineProperty2.default)(this, "configure", function (config) {
    var validator = config.validator,
        visitorManager = config.visitorManager;

    if (!validator && !visitorManager) {
      throw new Error("Configure in canner-script must have the following key: validator, visitorManager, but receive ".concat(JSON.stringify(config)));
    }

    if (validator) {
      _validator.default.setConfig(validator);
    }

    if (visitorManager) {
      var defaultVisitors = visitorManager.defaultVisitors,
          visitors = visitorManager.visitors;

      if (defaultVisitors) {
        _visitorManager.default.setDefaultVisitors(defaultVisitors);
      }

      if (visitors && visitors.length) {
        visitors.forEach(function (visitor) {
          _visitorManager.default.addVisitor(visitor);
        });
      }

      if (visitors && !visitors.length) {
        _visitorManager.default.resetVisitors();
      }
    }
  });
};

var _default = new Configuration();

exports.default = _default;