"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _basic = _interopRequireDefault(require("./basic"));

var _saferEval = _interopRequireDefault(require("safer-eval"));

var JsonModal =
/*#__PURE__*/
function (_BasicModel) {
  (0, _inherits2.default)(JsonModal, _BasicModel);

  function JsonModal(attrs, children) {
    var _this;

    (0, _classCallCheck2.default)(this, JsonModal);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(JsonModal).call(this, 'json', attrs));
    var builder = _this.attributes.builder;

    if (typeof builder === 'string') {
      builder = (0, _saferEval.default)(builder);
    }

    if (typeof builder === 'function') {
      // $FlowFixMe
      _this.toJson = function () {
        return builder({
          attributes: (0, _objectSpread2.default)({}, attrs, {
            builder: undefined,
            type: 'json'
          }),
          children: children
        });
      };

      return (0, _possibleConstructorReturn2.default)(_this, (0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    }

    if (children && children.length) {
      _this.attributes.items = children.reduce(function (result, child) {
        if (child.keyName in result) {
          throw new Error("duplicated keyName in children of ".concat(_this.attributes.keyName));
        }

        result[child.keyName] = child;
        return result;
      }, {});
    }

    return _this;
  }

  return JsonModal;
}(_basic.default);

exports.default = JsonModal;