"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _utils = require("../utils");

var _visitorManager = _interopRequireDefault(require("../visitorManager"));

var RootModel =
/*#__PURE__*/
function () {
  function RootModel(attrs, children) {
    var _this = this;

    (0, _classCallCheck2.default)(this, RootModel);
    (0, _defineProperty2.default)(this, "items", void 0);
    (0, _defineProperty2.default)(this, "keyName", void 0);
    (0, _defineProperty2.default)(this, "dict", void 0);
    (0, _defineProperty2.default)(this, "schema", void 0);
    (0, _defineProperty2.default)(this, "pageSchema", void 0);
    (0, _defineProperty2.default)(this, "connector", void 0);
    (0, _defineProperty2.default)(this, "resolvers", void 0);
    (0, _defineProperty2.default)(this, "visitors", void 0);
    (0, _defineProperty2.default)(this, "entry", void 0);
    (0, _defineProperty2.default)(this, "imageStorages", void 0);
    (0, _defineProperty2.default)(this, "fileStorages", void 0);
    (0, _defineProperty2.default)(this, "graphqlClient", void 0);
    var dataSchema = children.slice().filter(function (child) {
      return child.type === 'object' || child.type === 'array';
    }).reduce(function (result, child) {
      if (child.keyName in result) {
        throw new Error("Schema Error: duplicated name in children of ".concat(_this.keyName));
      }

      if (child.type === 'array' && !child.toolbar) {
        // default pagination in first array
        child.toolbar = {
          pagination: {}
        };
      }

      result[child.keyName] = child;
      return result;
    }, {});
    var pageSchema = children.filter(function (child) {
      return child.type === 'page';
    }).reduce(function (result, child) {
      result[child.keyName] = child;
      return result;
    }, {});
    this.dict = attrs.dict || {};
    this.schema = dataSchema;
    this.pageSchema = pageSchema;
    this.visitors = _visitorManager.default.getAllVisitors();
    this.imageStorages = (0, _utils.genStorages)(attrs, children, 'imageStorage');
    this.fileStorages = (0, _utils.genStorages)(attrs, children, 'fileStorage');
    this.resolvers = (0, _utils.parseResolvers)(attrs, children);
    this.connector = (0, _utils.parseConnector)(attrs, children) || (0, _utils.parseConnector)(attrs, children);
    this.graphqlClient = (0, _utils.parseGraphqlClient)(attrs, children) || (0, _utils.parseGraphqlClients)(attrs, children);
  }

  (0, _createClass2.default)(RootModel, [{
    key: "toJson",
    value: function toJson() {
      return {
        dict: this.dict,
        schema: this.schema,
        pageSchema: this.pageSchema,
        visitors: this.visitors,
        imageStorages: this.imageStorages,
        fileStorages: this.fileStorages,
        resolvers: this.resolvers,
        connector: this.connector,
        graphqlClient: this.graphqlClient
      };
    }
  }]);
  return RootModel;
}();

exports.default = RootModel;