"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/**
  these vistors handles the body layout that all first level components will move into
 */
var arrayBody = {
  'component.array': {
    exit: function exit(path) {
      if (path.node.inBody) {
        // already has body layout
        return;
      }

      if (path.node.pattern === 'array') {
        var componentInBody = {
          nodeType: 'layout.body',
          ui: "body",
          children: [{
            nodeType: 'layout.block',
            ui: "block",
            children: [path.node]
          }]
        }; // remove title description to body container

        path.node.hideTitle = true;
        path.tree.setNode(path.route, componentInBody);
      }
    }
  }
};
var objectBody = {
  'component.object': {
    exit: function exit(path) {
      if (path.node.inBody) {
        // already has body layout
        return;
      }

      if (path.node.pattern === 'object') {
        var componentInBody = {
          nodeType: 'layout.body',
          ui: 'body',
          children: [{
            nodeType: 'layout.block',
            ui: "block",
            children: [path.node]
          }]
        }; // hide first layer title decsription to body container

        path.node.hideTitle = true;
        path.tree.setNode(path.route, componentInBody);
      }
    }
  }
};
var pageBody = {
  'page.page': {
    exit: function exit(path) {
      if (path.node.inBody) {
        // already has body layout
        return;
      }

      var componentInBody = {
        nodeType: 'layout.body',
        ui: "body",
        children: [path.node]
      }; // remove title description to body container

      path.node.hideTitle = true;
      path.tree.setNode(path.route, componentInBody);
    }
  }
};
var _default = [arrayBody, objectBody, pageBody];
exports.default = _default;